/*
 *  exo01.c
 *  carrés successifs avec operations bit
 *  Je l'include juste pour les plus curieux
 *  on ne vous demande pas d'utiliser ce genre d'operations
 *  si vous n'étez pas intéressés, vous pouvez ignorer ce fichier
 */

#include <stdio.h>

double puiss(double b, unsigned int e) {
  double res = 1;
  while (e) {
    if(e & 1) { // &: on fait un "et" sur tous les bits
                // on le peut utiliser comme masque
                // dans ce cas on fait un "et" avec 00...001,
                // donc on extrait le dernier bit de e
      res *= b;
    }
    e >>= 1;  // decalage: e>>1 sont les bits de e decalés d'une place à
              // droite (en effaçant celui plus à droite)
              // pour ex. 1110011 --> 111001
              // l'effet est de divider par deux
    b *= b;
  }
  return res;
}

int main() {
  double b;
  unsigned int e;
  printf("Bonjour !\n");
  printf("Svp, tapez un réel : ");
  scanf("%lf",&b);
  printf("Svp, tapez un naturel : ");
  scanf("%d",&e);
  printf("La %de puissance de %lf est %lf\nAu revoir !\n",e,b,puiss(b,e));
}

/* 
 * les operations bit agissent directement sur les bits d'une variable
 * a << n : decalage de a à gauche de n bits, en introduisant des 0
 *          ex. 110111011 << 3 == 110111011000
 *          effet sur les unsigned int : multiplication par 2^n
 * a >> n : decalage à droite
 *          ex. 110111011 >> 3 == 110111
 *          effet sur les unsigned int : division entière par 2^n
 * a | b :  "ou" par bits
 *          ex. 10100011 |
 *              11001010 ==
 *              11101011
 * a & b :  "et" par bits
 *          ex. 10100011 &
 *              11001010 ==
 *              10000010
 * a ^ b :  "ou" exclusif par bits (somme sur le champ F_2)
 *          ex. 10100011 ^
 *              11001010 ==
 *              01101001
 * Un petit truc sympa avec le ^ : la fonction swap sans utiliser
 * une variable d'appuie. Pour echanger les valeurs de x et y
 * on peut faire les trois operation suivantes
 *  x ^= y;
 *  y ^= x;
 *  x ^= y;
 * l'effet est, si x et y ont comme valeurs initielles a et b,
 * 
 *   op   |     x      |      y     |
 * -------|------------|------------|
 *    -   |     a      |      b     |
 * -------|------------|------------|
 * x ^= y |    a^b     |      b     |
 * -------|------------|------------|
 * y ^= x |    a^b     | b^a^b == a |   car b^b == 0 et a^0 == a
 * -------|------------|------------|
 * x ^= y | a^b^a == b |      a     |   car a^a == 0 et b^0 == b
 */
